Name:		dpm-postgres
Version:	1.7.3.1
Release:	2%{?dist}
Summary:	Disk Pool Manager (DPM) server with postgres database backend

Group:		Applications/Internet
License:	ASL 2.0
URL:		http://glite.web.cern.ch/glite/
#		cvs -d:pserver:anonymous@glite.cvs.cern.ch:/cvs/glite \
#		    co -r LCG-DM_R_1_7_3_1 -d LCG-DM-1.7.3.1 LCG-DM
#		tar --exclude CVS -z -c -f LCG-DM-1.7.3.1.tar.gz LCG-DM-1.7.3.1
Source0:	LCG-DM-%{version}.tar.gz
#		Fix non-standard installation path
#		https://savannah.cern.ch/bugs/?57526
Patch0:		LCG-DM-paths.patch
#		Link using $(CC)
#		https://savannah.cern.ch/bugs/?57527
Patch1:		LCG-DM-ld.patch
#		Fix soname issues
#		https://savannah.cern.ch/bugs/?57528
Patch2:		LCG-DM-withsoname.patch
#		Link binaries using shared libraries
#		https://savannah.cern.ch/bugs/?57529
Patch3:		LCG-DM-shliblink.patch
#		Link to gsoap library, mix parallel build
#		https://savannah.cern.ch/bugs/?57530
Patch4:		LCG-DM-gsoap.patch
#		Fix non-standard install permissions
#		https://savannah.cern.ch/bugs/?57531
Patch5:		LCG-DM-installpermissions.patch
#		Fix init script issues
#		https://savannah.cern.ch/bugs/?57532
Patch6:		LCG-DM-initscripts.patch
#		Fix man page installation
#		https://savannah.cern.ch/bugs/?57533
Patch7:		LCG-DM-man.patch
#		Fix parallel build and other makefile glitches
#		https://savannah.cern.ch/bugs/?57534
Patch8:		LCG-DM-rules.patch
#		Postgres include path
#		https://savannah.cern.ch/bugs/?57535
Patch9:		LCG-DM-posinc.patch
#		Adapt upstream's hardcoded include and library paths for Fedora
Patch10:	LCG-DM-usr.patch
#		Allow moving plugins out of default library search path
Patch11:	LCG-DM-dlopen.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	CGSI-gSOAP-devel%{?_isa}
BuildRequires:	globus-gass-copy-devel%{?_isa}
BuildRequires:	globus-ftp-client-devel%{?_isa}
BuildRequires:	voms-devel%{?_isa}
BuildRequires:	gsoap-devel%{?_isa}
BuildRequires:	postgresql-devel%{?_isa}
%if %{?fedora}%{!?fedora:0} >= 12 || %{?rhel}%{!?rhel:0} >= 6
BuildRequires:	libuuid-devel%{?_isa}
%else
BuildRequires:	e2fsprogs-devel%{?_isa}
%endif
BuildRequires:	lcgdm-devel%{?_isa}
BuildRequires:	dpm-devel%{?_isa}

Requires(pre):		shadow-utils
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description
Disk Pool Manager (DPM) server that uses postgres as its database backend

%package nameserver
Summary:	DPM nameserver with postgres database backend
Group:		Applications/Internet
Requires:	dpm-postgres%{?_isa}

Requires(pre):		dpm-postgres
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description nameserver
Disk Pool Manager (DPM) nameserver that uses postgres as its database backend

%package copyd
Summary:	DPM cpoy server with postgres database backend
Group:		Applications/Internet
Requires:	dpm-postgres%{?_isa}

Requires(pre):		dpm-postgres
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description copyd
Disk Pool Manager (DPM) copy server that uses postgres as its database backend

%package srmv1
Summary:	DPM SRM version 1 server with postgres database backend
Group:		Applications/Internet
Requires:	dpm-postgres%{?_isa}

Requires(pre):		dpm-postgres
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description srmv1
Disk Pool Manager (DPM) SRM version 1 server that uses postgres as its
database backend

%package srmv2
Summary:	DPM SRM version 2 server with postgres database backend
Group:		Applications/Internet
Requires:	dpm-postgres%{?_isa}

Requires(pre):		dpm-postgres
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description srmv2
Disk Pool Manager (DPM) SRM version 2 server that uses postgres as its
database backend

%package srmv22
Summary:	DPM SRM version 2.2 server with postgres database backend
Group:		Applications/Internet
Requires:	dpm-postgres%{?_isa}

Requires(pre):		dpm-postgres
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description srmv22
Disk Pool Manager (DPM) SRM version 2.2 server that uses postgres as its
database backend

%prep
%setup -q -n LCG-DM-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

chmod 644 security/globus_gsi_gss_constants.h \
	  security/globus_i_gsi_credential.h \
	  security/gssapi_openssl.h
chmod 644 doc/lfc/INSTALL-*

# Use full path to plugins (see patch #11)
sed 's!@@LIBDIR@@!%{_libdir}!' -i security/Csec_api_loader.c

%build
# The code violates the strict aliasing rules all over the place...
# Need to use -fnostrict-aliasing so that the -O2 optimization in
# optflags doesn't try to use them.
sed 's/^CC +=/& %{optflags} -fno-strict-aliasing/' -i config/linux.cf

gsoapversion=`soapcpp2 -v 2>&1 | grep Compiler | sed 's/.* //'`

./configure dpm --with-postgres \
	--libdir=%{_lib} \
	--with-gsoap-location=%{_prefix} \
	--with-gsoap-version=$gsoapversion \
	--with-voms-location=%{_prefix} \
	--with-dpm-config-file=%{_sysconfdir}/DPMCONFIG \
	--with-id-map-file=%{_sysconfdir}/lcgdm-mapfile \
	--with-ns-config-file=%{_sysconfdir}/DPNSCONFIG \
	--with-sysconf-dir='$(prefix)/../etc'

sed -e 's/\(BuildDPMClient	*\)YES/\1NO/' \
    -e 's/\(BuildInterfaces	*\)YES/\1NO/' \
    -e 's/\(BuildNameServerClient	*\)YES/\1NO/' \
    -e 's/\(BuildNameServerLibrary	*\)YES/\1NO/' \
    -e 's/\(BuildRfioClient	*\)YES/\1NO/' \
    -e 's/\(BuildRfioServer	*\)YES/\1NO/' -i config/site.def

sed '/^\#define.*YES/d' -i config/Project.tmpl config/Library.tmpl
sed '/^SECURITYDIR =/d' -i config/Project.tmpl

echo '#!/bin/sh' > cpp
echo '/lib/cpp -Ui386 "$@"' >> cpp
chmod +x cpp
IMAKECPP=${PWD}/cpp make -f Makefile.ini Makefiles

make %{?_smp_mflags} prefix=%{_prefix}

%install
rm -rf ${RPM_BUILD_ROOT}

make prefix=${RPM_BUILD_ROOT}%{_prefix} install
make prefix=${RPM_BUILD_ROOT}%{_prefix} install.man

mv ${RPM_BUILD_ROOT}%{_datadir}/DPM ${RPM_BUILD_ROOT}%{_datadir}/dpm

mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres

# dpm startup script
sed -e 's/LD_LIBRARY_PATH=$LD_LIBRARY_PATH //' \
    -e '/LD_LIBRARY_PATH/d' \
    -e 's!/opt/lcg/bin!/usr/sbin!g' -e 's!/opt/lcg!!g' \
    -e 's!\(/var/lock/subsys/\).*!\1dpm-postgres!' \
    -e 's/	/    /g' \
    ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.dpm > \
    ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres
chmod 755 ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres
rm ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.dpm

# dpm configuration file
sed -e 's!/opt/lcg!!g' \
    -e 's/\(^DPNS_HOST=\).*/\1`hostname -f`/' \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm.conf.templ > \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpm.conf
rm ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm.conf.templ
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/dpm

# dpm log directory and log rotation configuration
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/dpm
install -m 644 dpm/dpm.logrotate \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpm.logrotate
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/dpm

# dpm binary and man page
mv ${RPM_BUILD_ROOT}%{_bindir}/dpm \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpm
touch ${RPM_BUILD_ROOT}%{_sbindir}/dpm
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/dpm
sed -e 's/\(\.TH [^ ]* \)1/\18/' \
    -e 's/dpm-shutdown(1)/dpm-shutdown(8)/g' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/dpm.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpm.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/dpm.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/dpm.8

mv ${RPM_BUILD_ROOT}%{_sysconfdir}/DPMCONFIG.templ \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/DPMCONFIG.templ
touch ${RPM_BUILD_ROOT}%{_datadir}/dpm/DPMCONFIG.templ

# dpm-shutdown binary and man page
mv ${RPM_BUILD_ROOT}%{_bindir}/dpm-shutdown \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpm-shutdown
touch ${RPM_BUILD_ROOT}%{_sbindir}/dpm-shutdown
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/dpm-shutdown
sed -e 's/\(\.TH [^ ]* \)1/\18/' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/dpm-shutdown.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpm-shutdown.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/dpm-shutdown.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/dpm-shutdown.8

# dpnsdaemon startup script
sed -e 's/LD_LIBRARY_PATH=$LD_LIBRARY_PATH //' \
    -e '/LD_LIBRARY_PATH/d' \
    -e 's!/opt/lcg/bin!/usr/sbin!g' -e 's!/opt/lcg!!g' \
    -e 's!\(/var/lock/subsys/\).*!\1dpm-postgres-nameserver!' \
    -e 's!/etc/NSCONFIG!/etc/DPNSCONFIG!g' \
    -e 's/	/    /g' \
    ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.dpnsdaemon > \
    ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres-nameserver
chmod 755 ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres-nameserver
rm ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.dpnsdaemon

# dpnsdaemon configuration file
sed -e 's!/opt/lcg!!g' \
    -e 's!/etc/NSCONFIG!/etc/DPNSCONFIG!g' \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpnsdaemon.conf.templ > \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpnsdaemon.conf
rm ${RPM_BUILD_ROOT}%{_sysconfdir}/dpnsdaemon.conf.templ
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/dpnsdaemon

# dpnsdaemon log directory and log rotation configuration
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/dpns
install -m 644 ns/dpnsdaemon.logrotate \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpnsdaemon.logrotate
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/dpnsdaemon

# dpnsdaemon binary and man page
mv ${RPM_BUILD_ROOT}%{_bindir}/dpnsdaemon \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpnsdaemon
touch ${RPM_BUILD_ROOT}%{_sbindir}/dpnsdaemon
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/dpnsdaemon
sed -e 's/\(\.TH [^ ]* \)1/\18/' \
    -e 's!/opt/lcg!!g' \
    -e 's!/etc/NSCONFIG!/etc/DPNSCONFIG!g' \
    -e 's/dpns-shutdown(1)/dpns-shutdown(8)/g' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/dpnsdaemon.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpnsdaemon.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/dpnsdaemon.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/dpnsdaemon.8

mv ${RPM_BUILD_ROOT}%{_sysconfdir}/NSCONFIG.templ \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/DPNSCONFIG.templ
touch ${RPM_BUILD_ROOT}%{_datadir}/dpm/DPNSCONFIG.templ

# dpns-shutdown binary and man page
mv ${RPM_BUILD_ROOT}%{_bindir}/dpns-shutdown \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpns-shutdown
touch ${RPM_BUILD_ROOT}%{_sbindir}/dpns-shutdown
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/dpns-shutdown
sed -e 's/\(\.TH [^ ]* \)1/\18/' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/dpns-shutdown.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpns-shutdown.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/dpns-shutdown.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/dpns-shutdown.8

# dpmcopyd startup script
sed -e 's/LD_LIBRARY_PATH=$LD_LIBRARY_PATH //' \
    -e '/LD_LIBRARY_PATH/d' \
    -e 's!/opt/lcg/bin!/usr/sbin!g' -e 's!/opt/lcg!!g' \
    -e 's!\(/var/lock/subsys/\).*!\1dpm-postgres-copyd!' \
    -e 's/	/    /g' \
    ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.dpmcopyd > \
    ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres-copyd
chmod 755 ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres-copyd
rm ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.dpmcopyd

# dpmcopyd configuration file
sed -e 's!/opt/lcg!!g' \
    -e 's/\(^DPNS_HOST=\).*/\1`hostname -f`/' \
    -e 's/\(^DPM_HOST=\).*/\1`hostname -f`/' \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpmcopyd.conf.templ > \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpmcopyd.conf
rm ${RPM_BUILD_ROOT}%{_sysconfdir}/dpmcopyd.conf.templ
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/dpmcopyd

# dpmcopyd log directory and log rotation configuration
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/dpmcopy
install -m 644 dpmcopy/dpmcopyd.logrotate \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpmcopyd.logrotate
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/dpmcopyd

# dpmcopyd binary and log file
mv ${RPM_BUILD_ROOT}%{_bindir}/dpmcopyd \
   ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpmcopyd
touch ${RPM_BUILD_ROOT}%{_sbindir}/dpmcopyd
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/dpmcopyd
sed -e 's/\(\.TH [^ ]*\) 1/\1 8/' \
    -e 's!/opt/lcg/lib/!!g' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/dpmcopyd.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpmcopyd.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/dpmcopyd.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/dpmcopyd.8

for svc in srmv1 srmv2 srmv2.2 ; do
    ssvc=`tr -d '.' <<< ${svc}`
    # startup script
    sed -e 's/LD_LIBRARY_PATH=$LD_LIBRARY_PATH //' \
	-e '/LD_LIBRARY_PATH/d' \
	-e 's!/opt/lcg/bin!/usr/sbin!g' -e 's!/opt/lcg!!g' \
	-e "s/${svc}/dpm-${svc}/g" \
	-e "s!\(/var/lock/subsys/\).*!\1dpm-postgres-${ssvc}!" \
	-e 's/	/    /g' \
	${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.${svc} > \
	${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres-${ssvc}
    chmod 755 ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres-${ssvc}
    rm ${RPM_BUILD_ROOT}%{_datadir}/dpm/rc.${svc}

    # configuration file
    sed -e "s/${svc}/dpm-${svc}/g" -e 's!/opt/lcg!!g' \
	-e 's/\(^DPNS_HOST=\).*/\1`hostname -f`/' \
	-e 's/\(^DPM_HOST=\).*/\1`hostname -f`/' \
	-e 's/\(^RUN_SRMV2DAEMON=\).*/\1"yes"/' \
	${RPM_BUILD_ROOT}%{_sysconfdir}/${svc}.conf.templ > \
	${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpm-${svc}.conf
    rm ${RPM_BUILD_ROOT}%{_sysconfdir}/${svc}.conf.templ
    touch ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/dpm-${svc}

    # log directory and log rotation configuration
    mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/dpm-${svc}
    sed -e "s/${svc}/dpm-${svc}/g" ${svc}/${svc}.logrotate > \
	${RPM_BUILD_ROOT}%{_sysconfdir}/dpm-postgres/dpm-${svc}.logrotate
    touch ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/dpm-${svc}

    # binary and makefile
    mv ${RPM_BUILD_ROOT}%{_bindir}/${svc} \
       ${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpm-${svc}
    touch ${RPM_BUILD_ROOT}%{_sbindir}/dpm-${svc}
    chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/dpm-${svc}
    sed -e 's/\.TH \([^ ]*\) 1/.TH DPM-\1 8/' \
	-e 's/dpm(1)/dpm(8)/g' \
	${RPM_BUILD_ROOT}%{_mandir}/man1/${svc}.1 | gzip -9 -n -c > \
	${RPM_BUILD_ROOT}%{_libdir}/dpm-postgres/dpm-${svc}.8.gz
    rm ${RPM_BUILD_ROOT}%{_mandir}/man1/${svc}.1
    touch ${RPM_BUILD_ROOT}%{_mandir}/man8/dpm-${svc}.8
done

# Create dpm user home
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/dpm

# Remove files already present in other packages
rm -rf ${RPM_BUILD_ROOT}%{_mandir}/man3
rm -rf ${RPM_BUILD_ROOT}%{_mandir}/man4
rm -rf ${RPM_BUILD_ROOT}%{_includedir}

# Turn off services by default
sed -e 's/\(chkconfig: \)\w*/\1-/' \
    -e '/Default-Start/d' \
    -e 's/\(Default-Stop: *\).*/\10 1 2 3 4 5 6/' \
    -i ${RPM_BUILD_ROOT}%{_initrddir}/dpm-postgres*

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
getent group dpmmgr > /dev/null || groupadd -r dpmmgr
getent passwd dpmmgr > /dev/null || useradd -r -g dpmmgr \
    -d %{_localstatedir}/lib/dpm -s /sbin/nologin -c "DPM Manager" dpmmgr
exit 0

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add dpm-postgres
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/dpm dpm \
	  %{_libdir}/dpm-postgres/dpm 20 \
  --slave %{_mandir}/man8/dpm.8.gz dpm.8.gz \
	  %{_libdir}/dpm-postgres/dpm.8.gz \
  --slave %{_datadir}/dpm/DPMCONFIG.templ DPMCONFIG.templ \
	  %{_libdir}/dpm-postgres/DPMCONFIG.templ \
  --slave %{_sysconfdir}/sysconfig/dpm dpm.conf \
	  %{_sysconfdir}/dpm-postgres/dpm.conf \
  --slave %{_sysconfdir}/logrotate.d/dpm dpm.logrotate \
	  %{_sysconfdir}/dpm-postgres/dpm.logrotate \
  --slave %{_sbindir}/dpm-shutdown dpm-shutdown \
	  %{_libdir}/dpm-postgres/dpm-shutdown \
  --slave %{_mandir}/man8/dpm-shutdown.8.gz dpm-shutdown.8.gz \
	  %{_libdir}/dpm-postgres/dpm-shutdown.8.gz \
  --initscript dpm-postgres

%preun
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display dpm | \
	grep currently | grep -q dpm-postgres && \
	/sbin/service dpm-postgres stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove dpm \
	%{_libdir}/dpm-postgres/dpm
    /sbin/chkconfig --del dpm-postgres
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service dpm-postgres condrestart > /dev/null 2>&1 || :
fi

%post nameserver
if [ $1 = 1 ]; then
    /sbin/chkconfig --add dpm-postgres-nameserver
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/dpnsdaemon dpnsdaemon \
	  %{_libdir}/dpm-postgres/dpnsdaemon 20 \
  --slave %{_mandir}/man8/dpnsdaemon.8.gz dpnsdaemon.8.gz \
	  %{_libdir}/dpm-postgres/dpnsdaemon.8.gz \
  --slave %{_datadir}/dpm/DPNSCONFIG.templ DPNSCONFIG.templ \
	  %{_libdir}/dpm-postgres/DPNSCONFIG.templ \
  --slave %{_sysconfdir}/sysconfig/dpnsdaemon dpnsdaemon.conf \
	  %{_sysconfdir}/dpm-postgres/dpnsdaemon.conf \
  --slave %{_sysconfdir}/logrotate.d/dpnsdaemon dpnsdaemon.logrotate \
	  %{_sysconfdir}/dpm-postgres/dpnsdaemon.logrotate \
  --slave %{_sbindir}/dpns-shutdown dpns-shutdown \
	  %{_libdir}/dpm-postgres/dpns-shutdown \
  --slave %{_mandir}/man8/dpns-shutdown.8.gz dpns-shutdown.8.gz \
	  %{_libdir}/dpm-postgres/dpns-shutdown.8.gz \
  --initscript dpm-postgres-nameserver

%preun nameserver
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display dpnsdaemon | \
	grep currently | grep -q dpm-postgres && \
	/sbin/service dpm-postgres-nameserver stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove dpnsdaemon \
	%{_libdir}/dpm-postgres/dpnsdaemon
    /sbin/chkconfig --del dpm-postgres-nameserver
fi

%postun nameserver
if [ $1 -ge 1 ]; then
    /sbin/service dpm-postgres-nameserver condrestart > /dev/null 2>&1 || :
fi

%post copyd
if [ $1 = 1 ]; then
    /sbin/chkconfig --add dpm-postgres-copyd
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/dpmcopyd dpmcopyd \
	  %{_libdir}/dpm-postgres/dpmcopyd 20 \
  --slave %{_mandir}/man8/dpmcopyd.8.gz dpmcopyd.8.gz \
	  %{_libdir}/dpm-postgres/dpmcopyd.8.gz \
  --slave %{_sysconfdir}/sysconfig/dpmcopyd dpmcopyd.conf \
	  %{_sysconfdir}/dpm-postgres/dpmcopyd.conf \
  --slave %{_sysconfdir}/logrotate.d/dpmcopyd dpmcopyd.logrotate \
	  %{_sysconfdir}/dpm-postgres/dpmcopyd.logrotate \
  --initscript dpm-postgres-copyd

%preun copyd
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display dpmcopyd | \
	grep currently | grep -q dpm-postgres && \
	/sbin/service dpm-postgres-copyd stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove dpmcopyd \
	%{_libdir}/dpm-postgres/dpmcopyd
    /sbin/chkconfig --del dpm-postgres-copyd
fi

%postun copyd
if [ $1 -ge 1 ]; then
    /sbin/service dpm-postgres-copyd condrestart > /dev/null 2>&1 || :
fi

%post srmv1
if [ $1 = 1 ]; then
    /sbin/chkconfig --add dpm-postgres-srmv1
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/dpm-srmv1 dpm-srmv1 \
	  %{_libdir}/dpm-postgres/dpm-srmv1 20 \
  --slave %{_mandir}/man8/dpm-srmv1.8.gz dpm-srmv1.8.gz \
	  %{_libdir}/dpm-postgres/dpm-srmv1.8.gz \
  --slave %{_sysconfdir}/sysconfig/dpm-srmv1 dpm-srmv1.conf \
	  %{_sysconfdir}/dpm-postgres/dpm-srmv1.conf \
  --slave %{_sysconfdir}/logrotate.d/dpm-srmv1 dpm-srmv1.logrotate \
	  %{_sysconfdir}/dpm-postgres/dpm-srmv1.logrotate \
  --initscript dpm-postgres-srmv1

%preun srmv1
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display dpm-srmv1 | \
	grep currently | grep -q dpm-postgres && \
	/sbin/service dpm-postgres-srmv1 stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove dpm-srmv1 \
	%{_libdir}/dpm-postgres/dpm-srmv1
    /sbin/chkconfig --del dpm-postgres-srmv1
fi

%postun srmv1
if [ $1 -ge 1 ]; then
    /sbin/service dpm-postgres-srmv1 condrestart > /dev/null 2>&1 || :
fi

%post srmv2
if [ $1 = 1 ]; then
    /sbin/chkconfig --add dpm-postgres-srmv2
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/dpm-srmv2 dpm-srmv2 \
	  %{_libdir}/dpm-postgres/dpm-srmv2 20 \
  --slave %{_mandir}/man8/dpm-srmv2.8.gz dpm-srmv2.8.gz \
	  %{_libdir}/dpm-postgres/dpm-srmv2.8.gz \
  --slave %{_sysconfdir}/sysconfig/dpm-srmv2 dpm-srmv2.conf \
	  %{_sysconfdir}/dpm-postgres/dpm-srmv2.conf \
  --slave %{_sysconfdir}/logrotate.d/dpm-srmv2 dpm-srmv2.logrotate \
	  %{_sysconfdir}/dpm-postgres/dpm-srmv2.logrotate \
  --initscript dpm-postgres-srmv2

%preun srmv2
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display dpm-srmv2 | \
	grep currently | grep -q dpm-postgres && \
	/sbin/service dpm-postgres-srmv2 stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove dpm-srmv2 \
	%{_libdir}/dpm-postgres/dpm-srmv2
    /sbin/chkconfig --del dpm-postgres-srmv2
fi

%postun srmv2
if [ $1 -ge 1 ]; then
    /sbin/service dpm-postgres-srmv2 condrestart > /dev/null 2>&1 || :
fi

%post srmv22
if [ $1 = 1 ]; then
    /sbin/chkconfig --add dpm-postgres-srmv22
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/dpm-srmv2.2 dpm-srmv2.2 \
	  %{_libdir}/dpm-postgres/dpm-srmv2.2 20 \
  --slave %{_mandir}/man8/dpm-srmv2.2.8.gz dpm-srmv2.2.8.gz \
	  %{_libdir}/dpm-postgres/dpm-srmv2.2.8.gz \
  --slave %{_sysconfdir}/sysconfig/dpm-srmv2.2 dpm-srmv2.2.conf \
	  %{_sysconfdir}/dpm-postgres/dpm-srmv2.2.conf \
  --slave %{_sysconfdir}/logrotate.d/dpm-srmv2.2 dpm-srmv2.2.logrotate \
	  %{_sysconfdir}/dpm-postgres/dpm-srmv2.2.logrotate \
  --initscript dpm-postgres-srmv22

%preun srmv22
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display dpm-srmv2.2 | \
	grep currently | grep -q dpm-postgres && \
	/sbin/service dpm-postgres-srmv22 stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove dpm-srmv2.2 \
	%{_libdir}/dpm-postgres/dpm-srmv2.2
    /sbin/chkconfig --del dpm-postgres-srmv22
fi

%postun srmv22
if [ $1 -ge 1 ]; then
    /sbin/service dpm-postgres-srmv22 condrestart > /dev/null 2>&1 || :
fi

%files
%defattr(-,root,root,-)
%dir %{_libdir}/dpm-postgres
%{_libdir}/dpm-postgres/dpm
%ghost %{_sbindir}/dpm
%{_libdir}/dpm-postgres/dpm-shutdown
%ghost %{_sbindir}/dpm-shutdown
%doc %{_libdir}/dpm-postgres/dpm.8*
%ghost %{_mandir}/man8/dpm.8*
%doc %{_libdir}/dpm-postgres/dpm-shutdown.8*
%ghost %{_mandir}/man8/dpm-shutdown.8*
%{_libdir}/dpm-postgres/DPMCONFIG.templ
%ghost %{_datadir}/dpm/DPMCONFIG.templ
%dir %{_sysconfdir}/dpm-postgres
%{_initrddir}/dpm-postgres
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm.conf
%ghost %{_sysconfdir}/sysconfig/dpm
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm.logrotate
%ghost %{_sysconfdir}/logrotate.d/dpm
%dir %{_datadir}/dpm
%{_datadir}/dpm/create_dpm_tables_postgres.sql
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/log/dpm
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/lib/dpm

%files nameserver
%defattr(-,root,root,-)
%{_libdir}/dpm-postgres/dpnsdaemon
%ghost %{_sbindir}/dpnsdaemon
%{_libdir}/dpm-postgres/dpns-shutdown
%ghost %{_sbindir}/dpns-shutdown
%doc %{_libdir}/dpm-postgres/dpnsdaemon.8*
%ghost %{_mandir}/man8/dpnsdaemon.8*
%doc %{_libdir}/dpm-postgres/dpns-shutdown.8*
%ghost %{_mandir}/man8/dpns-shutdown.8*
%{_libdir}/dpm-postgres/DPNSCONFIG.templ
%ghost %{_datadir}/dpm/DPNSCONFIG.templ
%{_initrddir}/dpm-postgres-nameserver
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpnsdaemon.conf
%ghost %{_sysconfdir}/sysconfig/dpnsdaemon
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpnsdaemon.logrotate
%ghost %{_sysconfdir}/logrotate.d/dpnsdaemon
%{_datadir}/dpm/create_dpns_tables_postgres.sql
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/log/dpns

%files copyd
%defattr(-,root,root,-)
%{_libdir}/dpm-postgres/dpmcopyd
%ghost %{_sbindir}/dpmcopyd
%doc %{_libdir}/dpm-postgres/dpmcopyd.8*
%ghost %{_mandir}/man8/dpmcopyd.8*
%{_initrddir}/dpm-postgres-copyd
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpmcopyd.conf
%ghost %{_sysconfdir}/sysconfig/dpmcopyd
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpmcopyd.logrotate
%ghost %{_sysconfdir}/logrotate.d/dpmcopyd
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/log/dpmcopy

%files srmv1
%defattr(-,root,root,-)
%{_libdir}/dpm-postgres/dpm-srmv1
%ghost %{_sbindir}/dpm-srmv1
%doc %{_libdir}/dpm-postgres/dpm-srmv1.8*
%ghost %{_mandir}/man8/dpm-srmv1.8*
%{_initrddir}/dpm-postgres-srmv1
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm-srmv1.conf
%ghost %{_sysconfdir}/sysconfig/dpm-srmv1
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm-srmv1.logrotate
%ghost %{_sysconfdir}/logrotate.d/dpm-srmv1
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/log/dpm-srmv1

%files srmv2
%defattr(-,root,root,-)
%{_libdir}/dpm-postgres/dpm-srmv2
%ghost %{_sbindir}/dpm-srmv2
%doc %{_libdir}/dpm-postgres/dpm-srmv2.8*
%ghost %{_mandir}/man8/dpm-srmv2.8*
%{_initrddir}/dpm-postgres-srmv2
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm-srmv2.conf
%ghost %{_sysconfdir}/sysconfig/dpm-srmv2
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm-srmv2.logrotate
%ghost %{_sysconfdir}/logrotate.d/dpm-srmv2
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/log/dpm-srmv2

%files srmv22
%defattr(-,root,root,-)
%{_libdir}/dpm-postgres/dpm-srmv2.2
%ghost %{_sbindir}/dpm-srmv2.2
%doc %{_libdir}/dpm-postgres/dpm-srmv2.2.8*
%ghost %{_mandir}/man8/dpm-srmv2.2.8*
%{_initrddir}/dpm-postgres-srmv22
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm-srmv2.2.conf
%ghost %{_sysconfdir}/sysconfig/dpm-srmv2.2
%config(noreplace) %{_sysconfdir}/dpm-postgres/dpm-srmv2.2.logrotate
%ghost %{_sysconfdir}/logrotate.d/dpm-srmv2.2
%attr(-,dpmmgr,dpmmgr) %{_localstatedir}/log/dpm-srmv2.2

%changelog
* Mon Nov 23 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.7.3.1-2
- Make dlopening work for standalone

* Tue Sep 22 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.7.3.1-1
- Update to version 1.7.3.1

* Fri Aug 14 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.7.2.5-1
- Initial build.
